<?php
namespace Fiscal\Logic\Impostos\Exceptions;

/**
 * A nota fiscal e/ou os produtos estao sem incidencia sem incidencia dos impostos obrigatorios.
 */
class ImpostoNaoCalculado extends \Fiscal\Logic\Exception
{

    private $messageName;
    
    public function __construct($messageName, $param = null, $code = 0, \Exception $previous = null) {
        parent::__construct($messageName, $code, $previous);
        $this->messageName = $messageName;

        if ($param)
            parent::setParams($param);
    }
    
    /**
     * Retorna o nome da mensagem cadastrada no Setforms para esta excecao.
     *
     * @return string
     */
    public static function impostosObrigatoriosNaoCalculados($param) {
        throw new self('msg_impostosObrigatoriosNaoCalculados', array($param));
    }
    
    public function getMessageName()
    {
        return $this->messageName;
    }

}