function Sup07200_lancamento_de_pedidos_Controller(ScreenService, templateManager, ZhFilterPreferences, MessageService, maskEngine, ZhUtil, General, Sup07200_lancamento_de_pedidos_Service) {
    var parametrosParaSupri;
    var parametrosGerais;
    var ServiceLancamentoPedidoOL = Sup07200_lancamento_de_pedidos_Service;
    var self = this;
    
    this.onEnterOnceWidgetPedidos = function(args) {
        const widget = args.owner;
        const rowsToSet = {};
        const widgetDadosPedido = templateManager.container.getWidget("dadosPedido");
        const widgetDetalhesPedido = templateManager.container.getWidget("detalhesPedido");
        var resp;
        
        widgetDadosPedido.enabled = false;
        widgetDetalhesPedido.enabled = false;
        
        ScreenService.showLoader();
        
        rowsToSet.defaultFilter = widget.dataSourceFilter;
        rowsToSet.TCDLOTENVITOL = 'N';
        rowsToSet.IDBAIXAAF = [ '0', '1', '2', '3', '4', '5' ];
        rowsToSet.PEDOLEXTR = [ 'S', 'N' ];
        rowsToSet.TRESERVA = [ 'S', 'N' ];
        
        General.callRestEngine("opl_solicitacao#/getCentralCompras", "Row", {}).then(function(response) {
            resp = response.dataset.data;
                
            if(resp) {
                if(resp.CDFILIAL == resp.CDFILCENTCMP) {
                    rowsToSet.NMFILIAL = [ resp.CDFILCENTCMP ];
                    
                    widget.currentRow.NMFILIAL = [ resp.CDFILCENTCMP ];
                } else {
                    rowsToSet.NMFILIAL = [ resp.CDFILIAL ];
                    
                    widget.currentRow.NMFILIAL = [ resp.CDFILIAL ];
                }
            }
            
            widget.getField("NMFILIAL").reload().then(function(resposta) {
                ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(opened => {
                    const filterWidget = templateManager.container.getActiveWidget();
                    const excluirReserva = widget.getAction("excluirReserva");
                    const incluirReserva = widget.getAction("incluirReserva");
                    const bloquearItemPedido = widget.getAction("bloquearItemPedido");
                    const desbloquearItemPedido = widget.getAction("desbloquearItemPedido");
                    const filter = [
                        {
        					"name": "CDFILIAL",
        					"operator": "=",
        					"value": resp.CDFILIAL
        				},
        				{
        					"name": "NRORG",
        					"operator": "=",
        					"value": resp.NRORG
        				}
        			];
        			
        			if(resp) {
        			    if(resp.CDFILIAL == resp.CDFILCENTCMP)
                            filterWidget.getField("NMFILIAL").readOnly = false;
                        else
                            filterWidget.getField("NMFILIAL").readOnly = true;
        			}
        			
                    filterWidget.getField("NMFILIAL").reload();
                    
                    filterWidget.activate();
        			
        			filterWidget.getAction("close").isVisible = false;
        			
                    ScreenService.hideLoader();
                    
                    General.callRestEngine("opl#/crud/paramgeral", "FilterData", []).then(function(response) {
                        parametrosGerais = response.dataset.paramgeral[0];
                        
                        General.callRestEngine("opl#/crud/parasupri", "FilterData", filter).then(function(response) {
                            parametrosParaSupri = response.dataset.parasupri[0];
                            
                            if(parametrosParaSupri && parametrosParaSupri.IDUTRESPEDEXOL === 'S') {
                                excluirReserva.isVisible = true;
                                incluirReserva.isVisible = true;
                            } else {
                                excluirReserva.isVisible = false;
                                incluirReserva.isVisible = false;
                            }
                            
                            var row = {
                                "CDOPERADOR": getLocalVar("CDOPERADOR")
                            };
                            
                            General.callRestEngine("opl_solicitacao#/checkOperBlockUnblockPer", "Row", row).then(function(response) {
                                var CDOPERADOR = response.dataset.CDOPERADOR.CDOPERADOR;
                                
                                if(CDOPERADOR) {
                                    if(CDOPERADOR == getLocalVar("CDOPERADOR")) {
                                        bloquearItemPedido.isVisible = true;
                                        desbloquearItemPedido.isVisible = true;
                                    } else {
                                        bloquearItemPedido.isVisible = false;
                                        desbloquearItemPedido.isVisible = false;
                                    }
                                } else {
                                    bloquearItemPedido.isVisible = false;
                                    desbloquearItemPedido.isVisible = false;
                                }
                            }).catch(function(error) {
                                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                                
                                bloquearItemPedido.isVisible = false;
                                desbloquearItemPedido.isVisible = false;
                            });
                        }).catch(function(error) {
                            excluirReserva.isVisible = false;
                            incluirReserva.isVisible = false;
                            
                            MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                        });
                    }).catch(function(error) {
                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                    });
                    
                }).catch(error => {
                    ScreenService.hideLoader();
                });
            });
        }).catch(function(error) {
            if(error.data.error == "CDFILCENTCMP_NOT_REGISTERED") {
                MessageService.showMessageByCode(error.data.error);
            } else {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            }
        });
    };
    
    this.changeFieldsRegiaoRotaUnidade = function(widget) {
        const fieldRegiao = widget.getField("CDREGIAO");
        const fieldRota = widget.getField("CDROTATRANS");
        const fieldUnidade = widget.getField("NMFILIAL");
        
        widget.currentRow.CDREGIAO = null;
        widget.currentRow.CDROTATRANS = null;
        widget.currentRow.CDFILIAL = null;
        widget.currentRow.NMFILIAL = null;
        
        fieldRegiao.clearValue();
        fieldRegiao.reload();
        
        fieldRota.clearValue();
        fieldRota.reload();
        
        fieldUnidade.clearValue();
        fieldUnidade.reload();
        fieldUnidade.dataSourceFilter = [
            {
                "name": "P_CDOPERADOR",
                "operator": "=",
                "value": "@getLocalVar('CDOPERADOR')@"
            },
            {
                "name": "P_TCDREGIAO",
                "operator": "=",
                "value": "T"
            },
            {
                "name": "P_CDREGIAO",
                "operator": "=",
                "value": ""
            },
            {
                "name": "P_CDGRUPFILI",
                "operator": "=",
                "value": widget.currentRow.CDGRUPFILI ? widget.currentRow.CDGRUPFILI : 'T'
            },
            {
                "name": "P_CDROTA",
                "operator": "=",
                "value": "T"
            }
        ];
        fieldUnidade.reload();
        
        widget.activate();
    };
    
    this.changeFieldsRotaUnidade = function(widget) {
        const fieldRota = widget.getField("CDROTATRANS");
        const fieldUnidade = widget.getField("NMFILIAL");
        
        widget.currentRow.CDROTATRANS = null;
        widget.currentRow.CDFILIAL = null;
        widget.currentRow.NMFILIAL = null;
        
        fieldRota.clearValue();
        fieldRota.reload();
        
        fieldUnidade.clearValue();
        fieldUnidade.reload();
        fieldUnidade.dataSourceFilter = [
            {
                "name": "P_CDOPERADOR",
                "operator": "=",
                "value": "@getLocalVar('CDOPERADOR')@"
            },
            {
                "name": "P_TCDREGIAO",
                "operator": "=",
                "value": widget.currentRow.CDREGIAO ? (widget.currentRow.CDREGIAO.length > 0) ? "" : 'T' : 'T'
            },
            {
                "name": "P_CDREGIAO",
                "operator": "=",
                "value": widget.currentRow.CDREGIAO ? (widget.currentRow.CDREGIAO.length > 0) ? widget.currentRow.CDREGIAO.join('_') : "" : ""
            },
            {
                "name": "P_CDGRUPFILI",
                "operator": "=",
                "value": widget.currentRow.CDGRUPFILI ? widget.currentRow.CDGRUPFILI : 'T'
            },
            {
                "name": "P_CDROTA",
                "operator": "=",
                "value": "T"
            }
        ];
        fieldUnidade.reload();
        
        widget.activate();
    };
    
    this.changeFieldsUnidade = function(widget) {
        const fieldUnidade = widget.getField("NMFILIAL");
        
        widget.currentRow.CDFILIAL = null;
        widget.currentRow.NMFILIAL = null;
        
        fieldUnidade.clearValue();
        fieldUnidade.reload();
        fieldUnidade.dataSourceFilter = [
            {
                "name": "P_CDOPERADOR",
                "operator": "=",
                "value": "@getLocalVar('CDOPERADOR')@"
            },
            {
                "name": "P_TCDREGIAO",
                "operator": "=",
                "value": widget.currentRow.CDREGIAO ? (widget.currentRow.CDREGIAO.length > 0) ? "" : 'T' : 'T'
            },
            {
                "name": "P_CDREGIAO",
                "operator": "=",
                "value": widget.currentRow.CDREGIAO ? (widget.currentRow.CDREGIAO.length > 0) ? widget.currentRow.CDREGIAO.join('_') : "" : ""
            },
            {
                "name": "P_CDGRUPFILI",
                "operator": "=",
                "value": widget.currentRow.CDGRUPFILI ? widget.currentRow.CDGRUPFILI : 'T'
            },
            {
                "name": "P_CDROTA",
                "operator": "=",
                "value": widget.currentRow.CDROTATRANS ? (widget.currentRow.CDROTATRANS.length > 0) ? widget.currentRow.CDROTATRANS.join('_') : 'T' : 'T'
            }
        ];
        fieldUnidade.reload();
        
        widget.activate();
    };
    
    this.changeFieldLote = function(widget) {
        const fieldlote = widget.getField("CDLOTENVITOL");
        
        if(widget.currentRow.TCDLOTENVITOL === 'L') {
            fieldlote.readOnly = false;
            fieldlote.reload();
            fieldlote.setValue(null);
        } else {
            fieldlote.readOnly = true;
            fieldlote.reload();
            fieldlote.setValue(null);
        }
        
        widget.activate();
    };
    
    this.changeFieldSubgrupo = function(widget) {
        const fieldSubgrupo = widget.getField("CDSUBGRPROD");
        
        if(widget.currentRow.NCONSIDERASUBGRUPO === 'N') {
            fieldSubgrupo.readOnly = false;
            fieldSubgrupo.reload();
            fieldSubgrupo.setValue(null);
        } else {
            fieldSubgrupo.readOnly = true;
            fieldSubgrupo.reload();
            fieldSubgrupo.setValue(null);
        }
        
        widget.activate();
    };
    
    this.filterProdIni = function(args) {
		var widget = args.owner.field.widget;
		var row = widget.currentRow;
		var prodIniIsSet = row.CDPRODINI ? true : false;
		
		if(!prodIniIsSet) {
			widget.currentRow.NMPRODFIN = '';
			widget.currentRow.CDPRODFIN = '';
            //widget.getField('NMPRODFIN').readOnly = true;
            //widget.getField('NMPRODFIN').readOnlyOnEdit = true;
            widget.currentRow.NMPRODFIN = null;
            widget.currentRow.CDPRODFIN = null;
		} else {
            //widget.getField('NMPRODFIN').readOnly = false;
            //widget.getField('NMPRODFIN').readOnlyOnEdit = false;
		}
        this.checkProductRange(args.owner.field);
	};
	
	this.filterProdFin = function(args) {
		var widget = args.owner.field.widget;
		var row = widget.currentRow;
		var prodFinIsSet = row.CDPRODFIN ? true : false;
		var prodIniIsSet = row.CDPRODINI ? true : false;
		
		if (prodFinIsSet) {
			if (row.CDPRODINI > row.CDPRODFIN) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
			}
		} else if(!prodIniIsSet) {
            //widget.getField('NMPRODFIN').readOnly = true;
            //widget.getField('NMPRODFIN').readOnlyOnEdit = true;
            widget.currentRow.NMPRODFIN = null;
            widget.currentRow.CDPRODFIN = null;
		}
		
		this.checkProductRange(args.owner.field);
	};
	
	this.checkProductRange = function(field) {
	   var currentRow = field.widget.currentRow;

		if (currentRow.CDPRODINI && currentRow.CDPRODFIN) {
			var compproduto = (currentRow.CDPRODFIN) ? currentRow.CDPRODFIN.replace(/[\.\-]/g, '') : null;

			if (!this.comparaPratoProduto(currentRow.CDPRODINI, compproduto, getLocalVar('CDPICTPROD'))) {
				currentRow[field.outData[field.descriptionField]] = null;
				currentRow[field.outData[field.valueField]] = null;

                field.widget.getField('NMPRODINI').clearValue();
                field.widget.getField('NMPRODFIN').clearValue();
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
			}
		}
	};
	
	this.comparaPratoProduto = function(pinicial, pfinal, mascara) {
        var mask = {
          type: "fix",
          params: {
              mask: mascara
          }
        };
        pinicial = Util.applyMask(pinicial, mask, maskEngine, ZhUtil).split('.');
        pfinal = Util.applyMask(pfinal, mask, maskEngine, ZhUtil).split('.');
        var nvinicial = pinicial.length;
        var nvfinal = pfinal.length;
        var resultado = true;
        if(nvinicial != nvfinal) {
            if(nvinicial > nvfinal) {
                resultado = false;
            }
        } else {
            var i = 0;
            do {
                if(pinicial[i] > pfinal[i]) {
                    resultado = false;
                }
                i++;
            }
            while (i<pinicial.length && resultado);
        }
        return resultado;
    };
    
    this.changeFieldBlock = function(widget) {
        const fieldBlock = widget.getField("DTBLOQ");
        
        if(widget.currentRow.TDTBLOQ === 'S') {
            fieldBlock.readOnly = false;
            fieldBlock.clearValue();
        } else {
            fieldBlock.readOnly = true;
            fieldBlock.clearValue();
        }
        
        widget.currentRow.DTBLOQ = {
            "start": "",
            "end": "",
            "formattedStart": "__/__/____",
            "formattedEnd": "__/__/____"
        };
        
        widget.activate();
    };
    
    this.changeFieldUnblock = function(widget) {
        const fieldUnblock = widget.getField("DTNBLOQ");
        
        if(widget.currentRow.TDTNBLOQ === 'S') {
            fieldUnblock.readOnly = false;
            fieldUnblock.clearValue();
        } else {
            fieldUnblock.readOnly = true;
            fieldUnblock.clearValue();
        }
        
        widget.currentRow.DTNBLOQ = {
            "start": "",
            "end": "",
            "formattedStart": "__/__/____",
            "formattedEnd": "__/__/____"
        };
        
        widget.activate();
    };
    
    this.setDataSourceFilter = function(args) {
        const filterRow = args.e.preference.FILTER_ROW;
        const widget = args.owner;
        const parametrosFinais = {
            "P_CDGRUPFILI": filterRow.CDGRUPFILI ? filterRow.CDGRUPFILI : null,
            "P_CDREGIAO": (!filterRow.CDREGIAO || filterRow.CDREGIAO.length == 0) ? null : '_' + filterRow.CDREGIAO.join('_') + '_',
            "P_TCDREGIAO": (!filterRow.CDREGIAO || filterRow.CDREGIAO.length == 0) ? 'T' : null,
            "P_CDFILIOPELOG": (!filterRow.NMFILIALOL || filterRow.NMFILIALOL.length == 0) ? null : '_' + filterRow.NMFILIALOL.join('_') + '_',
            "P_TCDFILIOPELOG": (!filterRow.NMFILIALOL || filterRow.NMFILIALOL.length == 0) ? 'T' : null,
            "P_CDFILIAL": (!filterRow.NMFILIAL || filterRow.NMFILIAL.length == 0) ? null : '_' + filterRow.NMFILIAL.join('_') + '_',
            "P_TCDFILIAL": (!filterRow.NMFILIAL || filterRow.NMFILIAL.length == 0) ? 'T' : null,
            "P_DTPEDINI": filterRow.DTPEDEXOL.start ? filterRow.DTPEDEXOL.start : null,
            "P_DTPEDFIN": filterRow.DTPEDEXOL.end ? filterRow.DTPEDEXOL.end : null,
            "P_DTEMBINI": filterRow.DTPROGEMBARQ.start ? filterRow.DTPROGEMBARQ.start : null,
            "P_DTEMBFIN": filterRow.DTPROGEMBARQ.end ? filterRow.DTPROGEMBARQ.end : null,
            "P_DTENTINI": filterRow.DTPROGENPEOL.start ? filterRow.DTPROGENPEOL.start : null,
            "P_DTENTFIN": filterRow.DTPROGENPEOL.end ? filterRow.DTPROGENPEOL.end : null,
            "P_CDPRODINI": filterRow.CDPRODINI ? filterRow.CDPRODINI : null,
            "P_CDPRODFIN": filterRow.CDPRODFIN ? (filterRow.CDPRODFIN + "ZZZZZZZZZZZZZZZZZZZZ").substr(0, 20) : null,
            "P_CDOPERADOR": getLocalVar('CDOPERADOR'),
            "P_DTBLOQINI": filterRow.TDTBLOQ === 'S' ? filterRow.DTBLOQ.start ? filterRow.DTBLOQ.start : null : null,
            "P_DTBLOQFIN": filterRow.TDTBLOQ === 'S' ? filterRow.DTBLOQ.end ? filterRow.DTBLOQ.end : null : null,
            "P_TBLOQ": filterRow.TDTBLOQ === 'S' ? null : 'T',
            "P_BLOQ": filterRow.TDTBLOQ === 'S' ? 'S' : 'N',
            "P_DTNBLOQINI": filterRow.TDTNBLOQ === 'S' ? filterRow.DTNBLOQ.start ? filterRow.DTNBLOQ.start : null : null,
            "P_DTNBLOQFIN": filterRow.TDTNBLOQ === 'S' ? filterRow.DTNBLOQ.end ? filterRow.DTNBLOQ.end : null : null,
            "P_TNBLOQ": filterRow.TDTNBLOQ === 'S' ? null : 'T',
            "P_NBLOQ": filterRow.TDTNBLOQ === 'S' ? 'S' : 'N',
            "P_PEDOLEXTR": filterRow.PEDOLEXTR.length == 2 ? 'T' : filterRow.PEDOLEXTR[0] === 'S' ? 'S' : 'N',
            "P_CDLOTENVIOL": (filterRow.TCDLOTENVITOL === 'S' || filterRow.TCDLOTENVITOL === 'N') ? 'T' : (!filterRow.CDLOTENVITOL || filterRow.CDLOTENVITOL.length == 0) ? 'T' : '_' + filterRow.CDLOTENVITOL.join('_') + '_',
            "P_TRESERVA": filterRow.TRESERVA.length == 2 ? '3' : filterRow.TRESERVA[0] === 'S' ? '1' : '2',
            "P_SUBGRUPO": filterRow.NCONSIDERASUBGRUPO === 'S' ? 'N' : (!filterRow.CDSUBGRPROD || filterRow.CDSUBGRPROD.length == 0) ? 'N' : '_' + filterRow.CDSUBGRPROD.join('_') + '_',
            "P_CDGRUPPROD": filterRow.NCONSIDERASUBGRUPO === 'S' ? null : (!filterRow.CDGRUPPROD || filterRow.CDGRUPPROD.length == 0) ? null : filterRow.CDGRUPPROD[0],
            "P_CDROTA": (!filterRow.CDROTATRANS || filterRow.CDROTATRANS.length == 0) ? 'T' : '_' + filterRow.CDROTATRANS.join('_') + '_',
            "P_IDBAIXAAF": (!filterRow.IDBAIXAAF || filterRow.IDBAIXAAF.length == 0) ? null : filterRow.IDBAIXAAF.length == 1 ? filterRow.IDBAIXAAF[0] :  '_' + filterRow.IDBAIXAAF.join('_') + '_'
        };
        const adicionaItemPedidoAction = widget.getAction("adicionaItemPedido");
        
        widget.dataSourceFilter = [
		    {
		        "name": "P_CDGRUPFILI",
		        "operator": "=",
		        "value": parametrosFinais.P_CDGRUPFILI
		    },
		    {
		        "name": "P_CDREGIAO",
		        "operator": "=",
		        "value": parametrosFinais.P_CDREGIAO
		    },
		    {
		        "name": "P_TCDREGIAO",
		        "operator": "=",
		        "value": parametrosFinais.P_TCDREGIAO
		    },
		    {
		        "name": "P_CDFILIOPELOG",
		        "operator": "=",
		        "value": parametrosFinais.P_CDFILIOPELOG
		    },
		    {
		        "name": "P_TCDFILIOPELOG",
		        "operator": "=",
		        "value": parametrosFinais.P_TCDFILIOPELOG
		    },
		    {
		        "name": "P_CDFILIAL",
		        "operator": "=",
		        "value": parametrosFinais.P_CDFILIAL
		    },
		    {
		        "name": "P_TCDFILIAL",
		        "operator": "=",
		        "value": parametrosFinais.P_TCDFILIAL
		    },
		    {
		        "name": "P_DTPEDINI",
		        "operator": "=",
		        "value": parametrosFinais.P_DTPEDINI
		    },
		    {
		        "name": "P_DTPEDFIN",
		        "operator": "=",
		        "value": parametrosFinais.P_DTPEDFIN
		    },
		    {
		        "name": "P_DTEMBINI",
		        "operator": "=",
		        "value": parametrosFinais.P_DTEMBINI
		    },
		    {
		        "name": "P_DTEMBFIN",
		        "operator": "=",
		        "value": parametrosFinais.P_DTEMBFIN
		    },
		    {
		        "name": "P_DTENTINI",
		        "operator": "=",
		        "value": parametrosFinais.P_DTENTINI
		    },
		    {
		        "name": "P_DTENTFIN",
		        "operator": "=",
		        "value": parametrosFinais.P_DTENTFIN
		    },
		    {
		        "name": "P_CDPRODINI",
		        "operator": "=",
		        "value": parametrosFinais.P_CDPRODINI
		    },
		    {
		        "name": "P_CDPRODFIN",
		        "operator": "=",
		        "value": parametrosFinais.P_CDPRODFIN
		    },
		    {
		        "name": "P_CDOPERADOR",
		        "operator": "=",
		        "value": parametrosFinais.P_CDOPERADOR
		    },
		    {
		        "name": "P_DTBLOQINI",
		        "operator": "=",
		        "value": parametrosFinais.P_DTBLOQINI
		    },
		    {
		        "name": "P_DTBLOQFIN",
		        "operator": "=",
		        "value": parametrosFinais.P_DTBLOQFIN
		    },
		    {
		        "name": "P_TBLOQ",
		        "operator": "=",
		        "value": parametrosFinais.P_TBLOQ
		    },
		    {
		        "name": "P_BLOQ",
		        "operator": "=",
		        "value": parametrosFinais.P_BLOQ
		    },
		    {
		        "name": "P_DTNBLOQINI",
		        "operator": "=",
		        "value": parametrosFinais.P_DTNBLOQINI
		    },
		    {
		        "name": "P_DTNBLOQFIN",
		        "operator": "=",
		        "value": parametrosFinais.P_DTNBLOQFIN
		    },
		    {
		        "name": "P_TNBLOQ",
		        "operator": "=",
		        "value": parametrosFinais.P_TNBLOQ
		    },
		    {
		        "name": "P_NBLOQ",
		        "operator": "=",
		        "value": parametrosFinais.P_NBLOQ
		    },
		    {
		        "name": "P_PEDOLEXTR",
		        "operator": "=",
		        "value": parametrosFinais.P_PEDOLEXTR
		    },
		    {
		        "name": "P_CDLOTENVIOL",
		        "operator": "=",
		        "value": parametrosFinais.P_CDLOTENVIOL
		    },
		    {
		        "name": "P_TRESERVA",
		        "operator": "=",
		        "value": parametrosFinais.P_TRESERVA
		    },
		    {
		        "name": "P_SUBGRUPO",
		        "operator": "=",
		        "value": parametrosFinais.P_SUBGRUPO
		    },
		    {
		        "name": "P_CDGRUPPROD",
		        "operator": "=",
		        "value": parametrosFinais.P_CDGRUPPROD
		    },
		    {
		        "name": "P_CDROTA",
		        "operator": "=",
		        "value": parametrosFinais.P_CDROTA
		    },
		    {
		        "name": "P_IDBAIXAAF",
		        "operator": "=",
		        "value": parametrosFinais.P_IDBAIXAAF
		    }
		];
		
		widget.reload().then(function(callback) {
            widget.activate();
            if(callback.dataset.sup07200_lancamento_de_pedidos_grid.length == 0) {
                adicionaItemPedidoAction.isVisible = false;
            } else {
                adicionaItemPedidoAction.isVisible = true;
            }
		});
    };
    
    this.widgetAfterMoveRow = function(args) {
        const widgetItensPedido = args.owner;
        const widgetDadosPedido = templateManager.container.getWidget("dadosPedido");
        const widgetDetalhesPedido = templateManager.container.getWidget("detalhesPedido");
        const widgetStripe = templateManager.container.getWidget("stripeWidget");
        
        ScreenService.showLoader();
        
        if(widgetItensPedido.currentRow.NRPEDEXOL) {
            if(widgetItensPedido.mode === "inline_edit") {
                widgetDadosPedido.enabled = false;
                widgetDetalhesPedido.enabled = false;
            } else {
                widgetDadosPedido.enabled = true;
                widgetDetalhesPedido.enabled = true;
            }
            
            
            widgetDetalhesPedido.dataSourceFilter = [
                {
                    "name": "P_CDPRODUTO",
                    "operator": "=",
                    "value": widgetItensPedido.currentRow.CDARVPROD
                },
                {
                    "name": "P_CDMARCA",
                    "operator": "=",
                    "value": widgetItensPedido.currentRow.CDMARCA
                },
                {
    		        "name": "P_CDFILLANC",
    		        "operator": "=",
    		        "value": widgetItensPedido.currentRow.CDFILLANC
    		    },
    		    {
    		        "name": "P_DTPROGENPEOL",
    		        "operator": "=",
    		        "value": moment(widgetItensPedido.currentRow.DTPROGENPEOL, 'L').format('L')
    		    },
    		    {
    		        "name": "P_CDFILDEST",
    		        "operator": "=",
    		        "value": widgetItensPedido.currentRow.CDFILDEST.split(" - ")[0]
    		    },
    		    {
    		        "name": "P_NRPEDEXOL",
    		        "operator": "=",
    		        "value": widgetItensPedido.currentRow.NRPEDEXOL
    		    }
            ];
            
            widgetDetalhesPedido.reload();
            
            widgetStripe.currentRow.NRPEDEXOL = widgetItensPedido.currentRow.NRPEDEXOL;
            widgetStripe.currentRow.CDFILLANC = widgetItensPedido.currentRow.CDFILLANC;
            widgetStripe.currentRow.IDBAIXENPEOL = widgetStripe.getField("IDBAIXENPEOL").options[widgetItensPedido.currentRow.IDBAIXENPEOL];
            widgetStripe.currentRow.IDBAIXAOLSAI = widgetStripe.getField("IDBAIXAOLSAI").options[widgetItensPedido.currentRow.IDBAIXAOLSAI];
            widgetStripe.currentRow.QTRESERVESTOL = widgetItensPedido.currentRow.QTRESERVESTOL;
            widgetStripe.currentRow.IDBAIXEXOL = widgetStripe.getField("IDBAIXEXOL").options[widgetItensPedido.currentRow.IDBAIXEXOL];
            widgetStripe.currentRow.DTPEDEXOL = moment(widgetItensPedido.currentRow.DTPEDEXOL, 'L').format('L');
            widgetStripe.currentRow.IDTIPOEXOL = widgetStripe.getField("IDTIPOEXOL").options[widgetItensPedido.currentRow.IDTIPOEXOL];
            
            General.callRestEngine("opl_solicitacao#/carregaDadosPedido", "Row", widgetItensPedido.currentRow).then(function(response) {
                const result = response.dataset.opl07200_dados_pedido;
                
                if(result) {
                    widgetDadosPedido.currentRow.NMFILLANC = result.NMFILLANC;
                    widgetDadosPedido.currentRow.CDFILLANC = result.CDFILLANC;
                    widgetDadosPedido.currentRow.NMFILDEST = result.NMFILDEST;
                    widgetDadosPedido.currentRow.CDFILDEST = result.CDFILDEST;
                    widgetDadosPedido.currentRow.NMFILIOPELOG = result.NMFILIOPELOG;
                    widgetDadosPedido.currentRow.CDFILIOPELOG = result.CDFILIOPELOG;
                    widgetDadosPedido.currentRow.DTPEDEXOL = result.DTPEDEXOL;
                    widgetDadosPedido.currentRow.IDPEDEXOLEXTR = result.IDPEDEXOLEXTR;
                    widgetDadosPedido.currentRow.CDEMPRESA = result.CDEMPRESA;
                    widgetDadosPedido.currentRow.IDTIPOEMITAF = result.IDEMITEXOL;
                    widgetDadosPedido.currentRow.NMTIPOEMITAF = result.IDEMITEXOL == '1' ? "Empresa da Unidade" : result.IDEMITEXOL == '2' ? "Empresa Informada" : "Cliente Principal";
                    widgetDadosPedido.currentRow.CDLOTENVITOL = widgetItensPedido.currentRow.CDLOTENVITOL ? widgetItensPedido.currentRow.CDLOTENVITOL : "";
                    widgetDadosPedido.currentRow.CDTIPCOB = result.CDTIPCOB;
                    widgetDadosPedido.currentRow.NMTIPOCOBR = result.NMTIPOCOBR;
                    widgetDadosPedido.currentRow.IDTIPOFRETAF = result.IDTPFRETEXOL;
                    widgetDadosPedido.currentRow.CDTPCTPAGAR = result.CDTPCTPAGAR;
                    widgetDadosPedido.currentRow.DSTPCTPAGAR = result.DSTPCTPAGAR;
                    widgetDadosPedido.currentRow.NRINSJURTRAN = result.NRINSJTREXOL;
                    widgetDadosPedido.currentRow.NMRAZSOCTRAN = result.NMRAZSOCTRAN;
                    widgetDadosPedido.currentRow.IDTPIJURTRAN = result.IDTPJTREXOL;
                    widgetDadosPedido.currentRow.IDBAIXEXOL = result.IDBAIXEXOL;
                    widgetDadosPedido.currentRow.IDBAIXEXSAI = result.IDBAIXEXSAI;
                    widgetDadosPedido.currentRow.NRPEDEXOL = result.NRPEDEXOL;
                    
                    widgetDadosPedido.getField("NMEMPRESA").dataSourceFilter[0].value = result.CDFILDEST;
                    widgetDadosPedido.getField("NMEMPRESA").dataSourceFilter[1].value = result.CDEMPRESA;
                    
                    widgetDadosPedido.getField("NMRAZSOCTRAN").dataSourceFilter[0].value = result.CDFILDEST;
                    widgetDadosPedido.getField("NMRAZSOCTRAN").dataSourceFilter[1].value = "";
                    widgetDadosPedido.getField("NMRAZSOCTRAN").dataSourceFilter[2].value = "";
                    
                    widgetDadosPedido.getField("NMLOTENVITOL").reload().then(data => {
                        let resultLote = data.dataset.lotes_all.filter(function(row) {
                            return row.CDLOTENVITOL == widgetItensPedido.currentRow.CDLOTENVITOL;
                        });
                        widgetDadosPedido.currentRow.NMLOTENVITOL = resultLote.length > 0 ? resultLote[0].NMLOTENVITOL : "";
                        widgetDadosPedido.currentRow.CDLOTENVITOL = resultLote.length > 0 ? resultLote[0].CDLOTENVITOL : "";
                    });
                    
                    self.destinatarioNF(widgetDadosPedido);
                    
                    if(result.IDBAIXEXOL == null || result.IDBAIXEXOL == '0' || result.IDBAIXEXOL == '1') {
                        widgetDadosPedido.getAction("editaDadosPedido").isVisible = true;
                        widgetDadosPedido.getAction("baixaManualPedido").isVisible = true;
                        widgetDadosPedido.getAction("cancelarPedido").isVisible = true;
                        widgetDadosPedido.getAction("encerrarPedido").isVisible = true;
                    } else {
                        widgetDadosPedido.getAction("editaDadosPedido").isVisible = false;
                        widgetDadosPedido.getAction("baixaManualPedido").isVisible = false;
                        widgetDadosPedido.getAction("cancelarPedido").isVisible = false;
                        widgetDadosPedido.getAction("encerrarPedido").isVisible = false;
                    }
                    
                    if(result.IDBAIXEXOL == '3' || result.IDBAIXEXOL == '4' || result.IDBAIXEXOL == '5') {
                        widgetDadosPedido.getAction("emAbertoPedido").isVisible = true;
                    } else {
                        widgetDadosPedido.getAction("emAbertoPedido").isVisible = false;
                    }
                    
                    if(result.IDBAIXEXOL == null || result.IDBAIXEXOL == '0') {
                        widgetDadosPedido.getAction("excluiPedido").isVisible = true;
                    } else {
                        widgetDadosPedido.getAction("excluiPedido").isVisible = false;
                    }
                    
                    if((parametrosParaSupri && parametrosParaSupri.IDENVIOITMPEDOL == 'S') && (result.IDBAIXEXOL == null || result.IDBAIXEXOL == '0')) {
                        widgetDadosPedido.getAction("exportarPedido").isVisible = true;
                    } else {
                        widgetDadosPedido.getAction("exportarPedido").isVisible = false;
                    }
                    
                    ScreenService.hideLoader();
                } else {
                    ScreenService.hideLoader();
                    
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": "Não foi possível carregar os dados do pedido." });
                }
            }).catch(function(error) {
                ScreenService.hideLoader();
                
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            });
        } else {
            widgetDadosPedido.enabled = false;
            widgetDetalhesPedido.enabled = false;
            
            ScreenService.hideLoader();
        }
    };
    
    this.adicionaItemPedido = function(widget) {
        const widgetAdicionaItemPedido = templateManager.container.getWidget("adicionaItemPedido");
        
        var mascaraProduto = getLocalVar('CDPICTPROD');
        var fieldProduto = widgetAdicionaItemPedido.getField('NMPRODUTO');
        
        mascaraProduto = mascaraProduto.split('.');
        
        var nivelProduto = mascaraProduto.length;
        
        fieldProduto.dataSourceFilter.forEach(function(filtro) {
            if(filtro.name == 'CDNVPRODUTO')
                filtro.value = nivelProduto;
        });
        
        if(widget.currentRow.NRPEDEXOL) {
            widgetAdicionaItemPedido.currentRow.NRPEDEXOL = widget.currentRow.NRPEDEXOL;
            widgetAdicionaItemPedido.currentRow.DTPROGENPEOL = moment(widget.currentRow.DTPROGENPEOL, 'L').format('L');
            //widgetAdicionaItemPedido.currentRow.CDPRODUTO = widget.currentRow.CDPRODUTO;
            //widgetAdicionaItemPedido.currentRow.CDARVPROD = widget.currentRow.CDARVPROD;
            //widgetAdicionaItemPedido.currentRow.CDPRODESTO = widget.currentRow.CDPRODESTO;
            //widgetAdicionaItemPedido.currentRow.NMPRODUTO = widget.currentRow.NMPRODUTO;
            //widgetAdicionaItemPedido.currentRow.SGUNIDADE = widget.currentRow.SGUNIDADE;
            widgetAdicionaItemPedido.currentRow.CDMARCA = widget.currentRow.CDMARCA;
            widgetAdicionaItemPedido.currentRow.NMMARCA = widget.currentRow.NMMARCA;
            widgetAdicionaItemPedido.currentRow.CDFILLANC = getLocalVar("CDFILIAL");
            widgetAdicionaItemPedido.currentRow.NMFILLANC = getLocalVar("NMFILIAL");
            widgetAdicionaItemPedido.currentRow.CDFILDEST = widget.currentRow.CDFILDEST.split(' - ')[0];
            widgetAdicionaItemPedido.currentRow.NMFILDEST = widget.currentRow.CDFILDEST.split(' - ')[1];
            widgetAdicionaItemPedido.currentRow.QTPROGENPEOL = widget.currentRow.QTPROGENPEOL;
            widgetAdicionaItemPedido.currentRow.CDFILIOPELOG = widget.currentRow.CDFILIOPELOG;
            
            widgetAdicionaItemPedido.getField("NMFILIOPELOG").reload().then(data => {
                let result = data.dataset.filial_ol.filter(function(row) {
                    return row.CDFILIAL == widget.currentRow.CDFILIOPELOG;
                });
                widgetAdicionaItemPedido.currentRow.NMFILIOPELOG = result[0].NMFILIAL;
            });
            
            widgetAdicionaItemPedido.getField("NRPEDEXOL").readOnly = true;
        } else {
            if(widget.dataSource.data.length > 0) {
                widgetAdicionaItemPedido.currentRow.NRPEDEXOL = widget.dataSource.data[0].NRPEDEXOL;
                widgetAdicionaItemPedido.currentRow.DTPROGENPEOL = moment(widget.dataSource.data[0].DTPROGENPEOL, 'L').format('L');
                //widgetAdicionaItemPedido.currentRow.CDPRODUTO = widget.dataSource.data[0].CDPRODUTO;
                //widgetAdicionaItemPedido.currentRow.CDARVPROD = widget.dataSource.data[0].CDARVPROD;
                //widgetAdicionaItemPedido.currentRow.CDPRODESTO = widget.dataSource.data[0].CDPRODESTO;
                //widgetAdicionaItemPedido.currentRow.NMPRODUTO = widget.dataSource.data[0].NMPRODUTO;
                //widgetAdicionaItemPedido.currentRow.SGUNIDADE = widget.dataSource.data[0].SGUNIDADE;
                widgetAdicionaItemPedido.currentRow.CDMARCA = widget.dataSource.data[0].CDMARCA;
                widgetAdicionaItemPedido.currentRow.NMMARCA = widget.dataSource.data[0].NMMARCA;
                widgetAdicionaItemPedido.currentRow.CDFILLANC = getLocalVar("CDFILIAL");
                widgetAdicionaItemPedido.currentRow.NMFILLANC = getLocalVar("NMFILIAL");
                widgetAdicionaItemPedido.currentRow.CDFILDEST = widget.dataSource.data[0].CDFILDEST.split(' - ')[0];
                widgetAdicionaItemPedido.currentRow.NMFILDEST = widget.dataSource.data[0].CDFILDEST.split(' - ')[1];
                widgetAdicionaItemPedido.currentRow.QTPROGENPEOL = widget.dataSource.data[0].QTPROGENPEOL;
                widgetAdicionaItemPedido.currentRow.CDFILIOPELOG = widget.dataSource.data[0].CDFILIOPELOG;
                
                widgetAdicionaItemPedido.getField("NMFILIOPELOG").reload().then(data => {
                    let result = data.dataset.filial_ol.filter(function(row) {
                        return row.CDFILIAL == widget.dataSource.data[0].CDFILIOPELOG;
                    });
                    widgetAdicionaItemPedido.currentRow.NMFILIOPELOG = result[0].NMFILIAL;
                });
                
                widgetAdicionaItemPedido.getField("NRPEDEXOL").readOnly = true;
            } else {
                widgetAdicionaItemPedido.currentRow.CDFILLANC = getLocalVar("CDFILIAL");
                widgetAdicionaItemPedido.currentRow.NMFILLANC = getLocalVar("NMFILIAL");
                widgetAdicionaItemPedido.currentRow.DTPROGENPEOL = moment().format('L');
                
                widgetAdicionaItemPedido.getField("NRPEDEXOL").readOnly = false;
            }
        }
        
        ScreenService.openSwipe(widgetAdicionaItemPedido);
    };
    
    this.salvaAdicaoItemPedido = function(widget) {
        const dataProc = moment(getLocalVar("DTPROCESSA"), "DD/MM/YYYY").format("MM-DD-YYYY");
        const dataEscd = moment(widget.currentRow.DTPROGENPEOL, "DD/MM/YYYY").format("MM-DD-YYYY");
        
        if(widget.isValid()) {
            if(moment(dataEscd).isSameOrAfter(dataProc)) {
                General.callRestEngine("opl_solicitacao#/checkIgualdadeItemPedidoOL", "Row", widget.currentRow).then(function(callback) {
                    General.callRestEngine("opl_solicitacao#/insereItemPedidoOL", "Row", widget.currentRow).then(function(response) {
                        widget.currentRow = {};
                        
                        MessageService.showMessageByCode("OPERACAO_SUCESSO");
                        
                        ScreenService.closeSwipe();
                        
                        const widgetItensPedido = widget.getParent();
                        
                        widgetItensPedido.activate();
                        widgetItensPedido.reload();
                    }).catch(function(error) {
                        if(error.data.error == "QTPROGENPEOL_EQUALS_ZERO")
                            MessageService.showMessageByCode(error.data.error);
                        else
                            MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                    });
                }).catch(function(error) {
                    if(error.data.error == "ITEM_ALREADY_EXISTS_PEDIDO" || error.data.error == "ERRO_QUERY") {
                        MessageService.showMessageByCode(error.data.error);
                    } else {
                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                    }
                });
            } else {
                MessageService.showMessageByCode("DATA_MAIOR_IGUAL_PROCESSAMENTO");
            }
        } else {
            MessageService.showMessageByCode("OBRIGATORY_FIELDS");
        }
    };
    
    this.excluiItemPedido = function(widget) {
        const rowsSelecionadas = widget.getCheckedRows();
        const rowsEmAberto = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0));
        });
        
        rowsSelecionadas.forEach(row => {
           row.DTPROGENPEOL = moment(row.DTPROGENPEOL, "DD/MM/YYYY").format("DD/MM/YYYY");
        });
        
        if(rowsEmAberto.length == rowsSelecionadas.length) {
            MessageService.confirmMessageByCode("CONFIRMA_EXCLUSAO_ITENS").then(function(confirmed) {
                General.callRestEngine("opl_solicitacao#/excluiItemPedidoOL", "Row", rowsSelecionadas).then(function(response) {
                    widget.activate();
                    widget.reload();
                    
                    MessageService.showMessageByCode("EXCLUSAO_REALIZADA");
                }).catch(function(error) {
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                });
            }).catch(function(error) {});
        } else {
            MessageService.showMessageByCode("ONLY_EM_ABERTO_ITENS_PEDIDO_DELETE");
        }
    };
    
    this.openWidgetAlteracaoDataEntregaItemPedido = function(widget) {
        const popUpWidget = templateManager.container.getWidget("alteracaoDataEntregaItemPedidoWidget");
        const rowsSelecionadas = widget.getCheckedRows();
        const rowsEmAberto = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0));
        });
        
        popUpWidget.currentRow = {};
        
        if(rowsEmAberto.length == rowsSelecionadas.length) {
            ScreenService.openPopup(popUpWidget);
        } else {
            MessageService.showMessageByCode("ONLY_EM_ABERTO_ITENS_PEDIDO_EDIT");
        }
    };
    
    this.salvaAlteracaoDataEntregaItemPedido = function(widget) {
        const dataProc = moment(getLocalVar("DTPROCESSA"), "DD/MM/YYYY").format("MM-DD-YYYY");
        const dataEscd = moment(widget.currentRow.NOVADTENTREGA, "DD/MM/YYYY").format("MM-DD-YYYY");
        const widgetItensPedido = widget.getParent();
        const rowsSelecionadas = widgetItensPedido.getCheckedRows();
        
        rowsSelecionadas.forEach(row => {
           row.NEW_DTPROGENPEOL = moment(widget.currentRow.NOVADTENTREGA, "DD/MM/YYYY").format("DD/MM/YYYY");
           row.DTPROGENPEOL = moment(row.DTPROGENPEOL, "DD/MM/YYYY").format("DD/MM/YYYY");
        });
        
        if(widget.isValid()) {
            if(moment(dataEscd).isSameOrAfter(dataProc)) {
                General.callRestEngine("opl_solicitacao#/alteraDataEntregaItemPedidoOL", "Row", rowsSelecionadas).then(function(response) {
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                    
                    widgetItensPedido.reload();
                    
                    MessageService.showMessageByCode("DTPROGENPEOL_EDIT_SUCCESS");
                }).catch(function(error) {
                    if(error.data.error == "DTPROGENPEOL_ALREADY_EXISTS_PEDIDO" || error.data.error == "ERRO_QUERY") {
                        MessageService.showMessageByCode(error.data.error);
                    } else {
                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                    }
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                    
                    widgetItensPedido.reload();
                });
            } else {
                MessageService.showMessageByCode("DATA_MAIOR_IGUAL_PROCESSAMENTO");
            }
        } else {
            MessageService.showMessageByCode("OBRIGATORY_FIELDS");
        }
    };
    
    this.openWidgetAlteracaoMarcaItemPedido = function(widget) {
        const popUpWidget = templateManager.container.getWidget("alteracaoMarcaItemPedidoWidget");
        const rowsSelecionadas = widget.getCheckedRows();
        const rowsEmAberto = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0));
        });
        
        popUpWidget.currentRow = {};
        
        if(rowsEmAberto.length == rowsSelecionadas.length) {
            ScreenService.openPopup(popUpWidget);
        } else {
            MessageService.showMessageByCode("ONLY_EM_ABERTO_ITENS_PEDIDO_EDIT");
        }
    };
    
    this.salvaAlteracaoMarcaItemPedido = function(widget) {
        const widgetItensPedido = widget.getParent();
        const rowsSelecionadas = widgetItensPedido.getCheckedRows();
        
        rowsSelecionadas.forEach(row => {
           row.NEW_CDMARCA = widget.currentRow.CDMARCA;
           row.OLD_CDMARCA = row.CDMARCA;
           row.DTPROGENPEOL = moment(row.DTPROGENPEOL, "DD/MM/YYYY").format("DD/MM/YYYY");
        });
        
        if(widget.isValid()) {
            General.callRestEngine("opl_solicitacao#/alteraMarcaItemPedidoOL", "Row", rowsSelecionadas).then(function(response) {
                ScreenService.closePopup();
                ScreenService.closePopup();
                    
                widgetItensPedido.reload();
                    
                MessageService.showMessageByCode("CDMARCA_EDIT_SUCCESS");
            }).catch(function(error) {
                if(error.data.error == "CDMARCA_ALREADY_EXISTS_PEDIDO" || error.data.error == "ERRO_QUERY") {
                    MessageService.showMessageByCode(error.data.error);
                } else {
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                }
                ScreenService.closePopup();
                ScreenService.closePopup();
                
                widgetItensPedido.reload();
            });
        } else {
            MessageService.showMessageByCode("OBRIGATORY_FIELDS");
        }
    };
    
    this.openWidgetAlteracaoProdutoItemPedido = function(widget) {
        const popUpWidget = templateManager.container.getWidget("alteracaoProdutoItemPedidoWidget");
        const rowsSelecionadas = widget.getCheckedRows();
        const rowBase = rowsSelecionadas[0];
        const rowsEmAberto = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0));
        });
        var permiteOperacao = true;
        
        for(let i = 0; i < rowsSelecionadas.length; i++) {
            if(rowsSelecionadas[i].CDARVPROD !== rowBase.CDARVPROD) {
                permiteOperacao = false;
                break;
            }
        }
        
        var mascaraProduto = getLocalVar('CDPICTPROD');
        var fieldProduto = popUpWidget.getField('NMPRODUTO');
        
        mascaraProduto = mascaraProduto.split('.');
        
        var nivelProduto = mascaraProduto.length;
        
        fieldProduto.dataSourceFilter.forEach(function(filtro) {
            if(filtro.name == 'CDNVPRODUTO')
                filtro.value = nivelProduto;
        });
        
        popUpWidget.currentRow = {};
        
        popUpWidget.currentRow.AJUSTE_UNIDADE = '0';
		popUpWidget.currentRow.AJUSTE_QUANTIDADE = '0';
        
        if(rowsEmAberto.length == rowsSelecionadas.length && permiteOperacao) {
            ScreenService.openPopup(popUpWidget);
        } else if(!permiteOperacao) {
            MessageService.showMessageByCode("OPR_BLOCK_DIFF_PRODUCTS");
        } else {
            MessageService.showMessageByCode("ONLY_EM_ABERTO_ITENS_PEDIDO_EDIT");
        }
    };
    
    this.onChangeAjuste = function(field) {
        var value = angular.copy(field.value()),
        	minValue = '-99.99';
        
        if(typeof(value) == 'string') {
            value = value.split('.').join('');
            value = value.replace(',', '.');
        }
        
        if(value && parseFloat(value) < parseFloat(minValue)) {
            field.setValue('0');
            MessageService.showMessageByCode("VLR_MENOR_MENOS_99");
        }
        
        if (Util.isEmptyOrBlank(field.value())) {
    		field.setValue('0');
    	}
    };
    
    this.salvaAlteracaoProdutoItemPedido = function(widget) {
        const widgetItensPedido = widget.getParent();
        const rowsSelecionadas = widgetItensPedido.getCheckedRows();
        
        rowsSelecionadas.forEach(row => {
           row.NEW_CDPRODUTO = widget.currentRow.CDPRODUTO;
           row.NEW_CDPRODESTO = widget.currentRow.CDPRODESTO;
           row.OLD_CDPRODUTO = row.CDPRODUTO;
           row.OLD_CDPRODESTO = row.CDPRODESTO;
           row.AJUSTE_UNIDADE = widget.currentRow.AJUSTE_UNIDADE;
           row.AJUSTE_QUANTIDADE = widget.currentRow.AJUSTE_QUANTIDADE;
           row.DTPROGENPEOL = moment(row.DTPROGENPEOL, "DD/MM/YYYY").format("DD/MM/YYYY");
        });
        
        if(widget.isValid()) {
            General.callRestEngine("opl_solicitacao#/alteraProdutoItemPedidoOL", "Row", rowsSelecionadas).then(function(response) {
                ScreenService.closePopup();
                ScreenService.closePopup();
                    
                widgetItensPedido.reload();
                    
                MessageService.showMessageByCode("CDPRODUTO_EDIT_SUCCESS");
            }).catch(function(error) {
                if(error.data.error == "CDPRODUTO_ALREADY_EXISTS_PEDIDO" || error.data.error == "ERRO_QUERY") {
                    MessageService.showMessageByCode(error.data.error);
                } else {
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                }
                ScreenService.closePopup();
                ScreenService.closePopup();
                
                widgetItensPedido.reload();
            });
        } else {
            MessageService.showMessageByCode("OBRIGATORY_FIELDS");
        }
    };
    
    this.openWidgetAlteracaoQuantidadeItemPedido = function(widget) {
        const popUpWidget = templateManager.container.getWidget("alteracaoQuantidadeItemPedidoWidget");
        const rowsSelecionadas = widget.getCheckedRows();
        const rowsEmAbertoParcial = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0 || row.IDBAIXENPEOL == 1) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0 || row.IDBAIXEXOL == 1));
        });
        
        popUpWidget.currentRow = {};
        
        if(rowsEmAbertoParcial.length == rowsSelecionadas.length) {
            ScreenService.openPopup(popUpWidget);
        } else {
            MessageService.showMessageByCode("ONLY_EMABERTO_PARCIAL_ITENS_PEDIDO_EDIT");
        }
    };
    
    this.salvaAlteracaoQuantidadeItemPedido = function(widget) {
        const widgetItensPedido = widget.getParent();
        const rowsSelecionadas = widgetItensPedido.getCheckedRows();
        
        rowsSelecionadas.forEach(row => {
           row.NEW_QTPROGENPEOL = widget.currentRow.QTPROGENPEOL;
           row.OLD_QTPROGENPEOL = row.QTPROGENPEOL;
           row.DTPROGENPEOL = moment(row.DTPROGENPEOL, "DD/MM/YYYY").format("DD/MM/YYYY");
        });
        
        if(widget.isValid()) {
            if(widget.currentRow.QTPROGENPEOL === "0,000" || widget.currentRow.QTPROGENPEOL === 0) {
                MessageService.confirmMessageByCode("CONFIRMA_EXCLUSAO_ITENS").then(function(confirmed) {
                    General.callRestEngine("opl_solicitacao#/excluiItemPedidoOL", "Row", rowsSelecionadas).then(function(response) {
                        ScreenService.closePopup();
                        ScreenService.closePopup();
                        
                        widgetItensPedido.reload();
                        
                        MessageService.showMessageByCode("EXCLUSAO_REALIZADA");
                    }).catch(function(error) {
                        ScreenService.closePopup();
                        ScreenService.closePopup();
                        
                        widgetItensPedido.reload();
                        
                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                    });
                }).catch(function(error) {});
            } else {
                General.callRestEngine("opl_solicitacao#/alteraQuantidadeItemPedidoOL", "Row", rowsSelecionadas).then(function(response) {
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                        
                    widgetItensPedido.reload();
                        
                    MessageService.showMessageByCode("QTPROGENPEOL_EDIT_SUCCESS");
                }).catch(function(error) {
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                    
                    widgetItensPedido.reload();
                    
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                });
            }
        } else {
            MessageService.showMessageByCode("OBRIGATORY_FIELDS");
        }
    };
    
    this.incluirLote = function(widget) {
        const popUpWidget = templateManager.container.getWidget("inclusaoDeLoteItemPedidoWidget");
        const rowsSelecionadas = widget.getCheckedRows();
        const rowsEmAberto = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0));
        });
        
        popUpWidget.currentRow = {};
        
        if(rowsEmAberto.length == rowsSelecionadas.length) {
            ScreenService.openPopup(popUpWidget);
        } else {
            MessageService.showMessageByCode("ONLY_EM_ABERTO_ITENS_PEDIDO_EDIT");
        }
    };
    
    this.salvaInclusaoDeLoteItemPedido = function(widget) {
        const widgetItensPedido = widget.getParent();
        const rowsSelecionadas = widgetItensPedido.getCheckedRows();
        const rowPai = rowsSelecionadas[0];
        
        rowPai.CDFILDEST1 = rowPai.CDFILDEST.split(" - ")[0];
        
        var inclusaoDeLote = false;
        
        rowsSelecionadas.forEach(row => {
            row.CDFILDEST1 = row.CDFILDEST.split(" - ")[0];
            row.NEW_CDLOTENVITOL = widget.currentRow.CDLOTENVITOL;
            row.OLD_CDLOTENVITOL = row.CDLOTENVITOL;
            row.DTPROGENPEOL = moment(row.DTPROGENPEOL, "DD/MM/YYYY").format("DD/MM/YYYY");
            
            if(row.CDFILIOPELOG == rowPai.CDFILIOPELOG && row.CDFILLANC == rowPai.CDFILLANC && row.CDFILDEST1 == rowPai.CDFILDEST1 && row.NRPEDEXOL == rowPai.NRPEDEXOL) {
                
            } else {
                inclusaoDeLote = true;
            }
        });
        
        if(inclusaoDeLote) {
            if(widget.isValid()) {
                General.callRestEngine("opl_solicitacao#/incluiItemPedidoLoteDiversos", "Row", rowsSelecionadas).then(function(response) {
                   ScreenService.closePopup();
                   ScreenService.closePopup();
                   
                   widgetItensPedido.reload();
                   
                   MessageService.showMessageByCode("CDLOTENVITOL_NEW_SUCCESS");
                }).catch(function(error) {
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                    
                    widgetItensPedido.reload();
                    
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                });
            } else {
                MessageService.showMessageByCode("OBRIGATORY_FIELDS");
            }
        } else {
           if(widget.isValid()) {
               General.callRestEngine("opl_solicitacao#/incluiItemPedidoLote", "Row", rowsSelecionadas).then(function(response) {
                   ScreenService.closePopup();
                   ScreenService.closePopup();
                   
                   widgetItensPedido.reload();
                   
                   MessageService.showMessageByCode("CDLOTENVITOL_NEW_SUCCESS");
                }).catch(function(error) {
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                    
                    widgetItensPedido.reload();
                    
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                });
            } else {
                MessageService.showMessageByCode("OBRIGATORY_FIELDS");
            } 
        }
    };
    
    this.incluirReserva = function(widget) {
        const rowsSelecionadas = widget.getCheckedRows();
        const rowsEmAberto = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0));
        });
        
        if(rowsEmAberto.length == rowsSelecionadas.length) {
            MessageService.confirmMessageByCode("RESERVA_QUESTION_INSERT").then(function(confirmed) {
                General.callRestEngine("opl_solicitacao#/inclusaoReservaItemPedido", "Row", rowsSelecionadas).then(function(response) {
                    ScreenService.closePopup();
                    
                    widget.reload();
                    
                    MessageService.showMessageByCode("RESEVA_NEW_SUCCESS");
                }).catch(function(error) {
                    ScreenService.closePopup();
                    
                    widget.reload();
                    
                    if(error.data.error == "QTD_INDISPONIVEL_RESERVA") {
                        MessageService.showMessageByCode(error.data.error);
                    } else {
                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                    }
                });
            });
        } else {
            MessageService.showMessageByCode("ONLY_EM_ABERTO_ITENS_PEDIDO_EDIT");
        }
    };
    
    this.excluirReserva = function(widget) {
        const rowsSelecionadas = widget.getCheckedRows();
        const rowsEmAberto = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0));
        });
        
        if(rowsEmAberto.length == rowsSelecionadas.length) {
            MessageService.confirmMessageByCode("RESERVA_QUESTION_DELETE").then(function(confirmed) {
                General.callRestEngine("opl_solicitacao#/exclusaoReservaItemPedido", "Row", rowsSelecionadas).then(function(response) {
                    ScreenService.closePopup();
                    
                    widget.reload();
                    
                    MessageService.showMessageByCode("RESEVA_DELETE_SUCCESS");
                }).catch(function(error) {
                    ScreenService.closePopup();
                    
                    widget.reload();
                    
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                });
            });
        } else {
            MessageService.showMessageByCode("ONLY_EM_ABERTO_ITENS_PEDIDO_EDIT");
        }
    };
    
    this.baixaManualItemPedido = function(widget) {
        const rowsSelecionadas = widget.getCheckedRows();
        const rowsEmAbertoParcial = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0 || row.IDBAIXENPEOL == 1) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0 || row.IDBAIXEXOL == 1));
        });
        
        rowsSelecionadas.forEach(row => {
           row.NEW_IDBAIXAOLSAI = '3';
           row.NEW_CDOPERBAIXA = getLocalVar("CDOPERADOR");
           row.NEW_DTBAIXTMPEOL = moment().format("DD/MM/YYYY");
           row.DTPROGENPEOL = moment(row.DTPROGENPEOL, "DD/MM/YYYY").format("DD/MM/YYYY");
        });
        
        if(rowsEmAbertoParcial.length == rowsSelecionadas.length) {
            MessageService.confirmMessageByCode("CONFIRMA_BAIXA_MANUAL").then(function(confirmed) {
                General.callRestEngine("opl_solicitacao#/baixaManualItemPedidoOL", "Row", rowsSelecionadas).then(function(response) {
                    ScreenService.closePopup();
                    
                    widget.reload();
                    
                    MessageService.showMessageByCode("BAIXA_MANUAL_SUCCESS");
                }).catch(function(error) {
                    ScreenService.closePopup();
                    
                    widget.reload();
                    
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                });
            });
        } else {
            MessageService.showMessageByCode("ONLY_EMABERTO_PARCIAL_ITENS_PEDIDO_EDIT");
        }
    };
    
    this.desbloquearItemPedido = function(widget) {
        const rowsSelecionadas = widget.getCheckedRows();
        const rowsEmAberto = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0));
        });
        const rowsDesbloqueadas = rowsSelecionadas.filter(function(row) {
            return (row.IDITMPEDOLBLOQ === 'N');
        });
        const rowsBloqueadas = rowsSelecionadas.filter(function(row) {
            return (row.IDITMPEDOLBLOQ === 'S' && ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0)));
        });
        
        rowsBloqueadas.forEach(row => {
           row.NEW_CDOPERADOR = getLocalVar("CDOPERADOR");
           row.NEW_IDITMPEDOLBLOQ = 'N';
           row.NEW_DTBLOQITMPEDOL = moment().format("DD/MM/YYYY");
           row.DTPROGENPEOL = moment(row.DTPROGENPEOL, "DD/MM/YYYY").format("DD/MM/YYYY");
        });
        
        if(rowsDesbloqueadas.length == rowsSelecionadas.length) {
            MessageService.showMessageByCode("ITEM_ALREADY_DESBLOQUEADO");
        } else {
            if(rowsEmAberto.length == rowsSelecionadas.length) {
                MessageService.confirmMessageByCode("CONFIRMA_DESBLOQUEIO_ITEM").then(function(confirmed) {
                    General.callRestEngine("opl_solicitacao#/desbloqueioBloqueioItemPedidoOL", "Row", rowsBloqueadas).then(function(response) {
                        widget.reload();
                        
                        MessageService.showMessageByCode("DESBLOQUEIO_SUCCESS");
                    }).catch(function(error) {
                        widget.reload();
                        
                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                    });
                });
            } else {
                MessageService.showMessageByCode("ONLY_EM_ABERTO_ITENS_PEDIDO_EDIT");
            }
        }
    };
    
    this.bloquearItemPedido = function(widget) {
        const rowsSelecionadas = widget.getCheckedRows();
        const rowsEmAberto = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0));
        });
        const rowsDesbloqueadas = rowsSelecionadas.filter(function(row) {
            return (row.IDITMPEDOLBLOQ === 'N' && ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0)));
        });
        const rowsBloqueadas = rowsSelecionadas.filter(function(row) {
            return (row.IDITMPEDOLBLOQ === 'S');
        });
        
        rowsDesbloqueadas.forEach(row => {
           row.NEW_CDOPERADOR = getLocalVar("CDOPERADOR");
           row.NEW_IDITMPEDOLBLOQ = 'S';
           row.NEW_DTBLOQITMPEDOL = moment().format("DD/MM/YYYY");
           row.DTPROGENPEOL = moment(row.DTPROGENPEOL, "DD/MM/YYYY").format("DD/MM/YYYY");
        });
        
        if(rowsBloqueadas.length == rowsSelecionadas.length) {
            MessageService.showMessageByCode("ITEM_ALREADY_BLOQUEADO");
        } else {
            if(rowsEmAberto.length == rowsSelecionadas.length) {
                MessageService.confirmMessageByCode("CONFIRMA_BLOQUEIO_ITEM").then(function(confirmed) {
                    General.callRestEngine("opl_solicitacao#/desbloqueioBloqueioItemPedidoOL", "Row", rowsDesbloqueadas).then(function(response) {
                        widget.reload();
                        
                        MessageService.showMessageByCode("BLOQUEIO_SUCCESS");
                    }).catch(function(error) {
                        widget.reload();
                        
                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                    });
                });
            } else {
                MessageService.showMessageByCode("ONLY_EM_ABERTO_ITENS_PEDIDO_EDIT");
            }
        }
    };
    
    this.entregaDiretaItemPedido = function(widget) {
        const popUpWidget = templateManager.container.getWidget("entregaDiretaItemPedidoWidget");
        const rowsSelecionadas = widget.getCheckedRows();
        const rowsEmAberto = rowsSelecionadas.filter(function(row) {
            return ((row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0) && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0));
        });
        
        popUpWidget.currentRow = {};
        
        if(rowsEmAberto.length == rowsSelecionadas.length) {
            ScreenService.openPopup(popUpWidget);
        } else {
            MessageService.showMessageByCode("ONLY_EM_ABERTO_ITENS_PEDIDO_EDIT");
        }
    };
    
    this.validaFieldOperador = function(widget) {
        widget.getField("SENHA").clearValue();
        widget.currentRow.SENHA = "";
        
        if(widget.currentRow.CDOPERADOR == getLocalVar("CDOPERADOR")) {
            delete  widget.getField("SENHA").validations;
            widget.getField("SENHA").readOnly = true;
        } else {
            widget.getField("SENHA").validations = {
                "required": true
            };
            widget.getField("SENHA").readOnly = false;
        }
        widget.activate();
    };
    
    this.validacoesLoginED = function(widget) {
        const widgetItensPedido = widget.getParent();
        const rowsSelecionadas = widgetItensPedido.getCheckedRows();
        
        rowsSelecionadas.forEach(row => {
            row.DTPROGENPEOL = moment(row.DTPROGENPEOL, "DD/MM/YYYY").format("DD/MM/YYYY");
            row.CDOPERADOR = widget.currentRow.CDOPERADOR;
        });
        
        if(widget.isValid()) {
            if(widget.currentRow.CDOPERADOR == getLocalVar("CDOPERADOR")) {
                General.callRestEngine("opl_solicitacao#/processoEntregaDiretaItemPedidoOL", "Row", rowsSelecionadas).then(function(response) {
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                        
                    widgetItensPedido.reload();
                        
                    MessageService.showMessageByCode("ENTREGA_DIRETA_ITEM_SUCCESS");
                }).catch(function(error) {
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                });
            } else {
                General.callRestEngine("opl_solicitacao#/validacaoSenhaED", "Row", widget.currentRow).then(function(response) {
                    General.callRestEngine("opl_solicitacao#/processoEntregaDiretaItemPedidoOL", "Row", rowsSelecionadas).then(function(response) {
                        ScreenService.closePopup();
                        ScreenService.closePopup();
                            
                        widgetItensPedido.reload();
                            
                        MessageService.showMessageByCode("ENTREGA_DIRETA_ITEM_SUCCESS");
                    }).catch(function(error) {
                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                    }); 
                }).catch(function(error) {
                    if(error.data.error == "INVALID_PASSWORD") {
                        MessageService.showMessageByCode(error.data.error);
                    } else {
                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                    }
                });
            }
        } else {
            MessageService.showMessageByCode("OBRIGATORY_FIELDS");
        }
    };
    
    this.destinatarioNF = function(widget) {
        if(widget.currentRow.IDTIPOEMITAF == '1') {
            widget.getField("NMEMPRESA").validations = { required: true };
            
            ServiceLancamentoPedidoOL.empresasPorUnidade(widget.currentRow).then(function(callback) {
                widget.currentRow.CDEMPRESA = callback.dataset.sup07200_empresas_por_unidade[0].CDEMPRESA;
				widget.currentRow.NMEMPRESA = callback.dataset.sup07200_empresas_por_unidade[0].NMEMPRESA;
				
				widget.getField("NMEMPRESA").readOnly = true;
            }).catch(function(error) {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            });
        } else if(widget.currentRow.IDTIPOEMITAF == '2') {
            widget.getField("NMEMPRESA").validations = { required: true };
			widget.getField("NMEMPRESA").dataSourceFilter[0].value = widget.currentRow.CDFILDEST;
			widget.getField("NMEMPRESA").readOnly = false;
			widget.getField("NMEMPRESA").reload();
			
			widget.currentRow.NMEMPRESA = '';
			widget.currentRow.CDEMPRESA = '';
        } else if(widget.currentRow.IDTIPOEMITAF == '3') {
            ServiceLancamentoPedidoOL.empresaClientePrincipal(widget.currentRow).then(function(callback) {
                if (callback.dataset.sup07200_empresa_cliente_principal.length) {
                    widget.currentRow.NMEMPRESA = callback.dataset.sup07200_empresa_cliente_principal[0].NMEMPRESA;
    			    widget.currentRow.CDEMPRESA = callback.dataset.sup07200_empresa_cliente_principal[0].CDEMPRESA;
                } else {
                    widget.currentRow.NMEMPRESA = '';
    			    widget.currentRow.CDEMPRESA = '';    
                }
                
                if (callback.dataset.sup07200_empresa_cliente_principal.length === 0) {
                    MessageService.showMessageByCode("SEM_CLIENTE_PRINCIPAL_FILIAL");
                    widget.currentRow.IDTIPOEMITAF = '2';
                    widget.currentRow.NMTIPOEMITAF = "Empresa Informada";
                    
                    widget.getField("NMEMPRESA").readOnly = false;
                    widget.getField("NMEMPRESA").validations = { required: true };
                    return false;
                } else {
                    widget.getField("NMEMPRESA").readOnly = true;
                    widget.getField("NMEMPRESA").validations = {};
                }
            }).catch(function(error) {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            });
        } else {
            widget.getField("NMEMPRESA").readOnly = true;
            widget.getField("NMEMPRESA").validations = {};
            
            widget.currentRow.NMEMPRESA = '';
			widget.currentRow.CDEMPRESA = '';
        }
    };
    
    this.editaDadosPedido = function(widget) {
        const oldRow = angular.copy(widget.currentRow);
        const itensPedidosWidget = templateManager.container.getWidget("itensPedidosWidget");
        const detalhesPedido = templateManager.container.getWidget("detalhesPedido");
        
        widget.oldRow = oldRow;
        widget.template = "widget/form.html";
        widget.edit();
        
        itensPedidosWidget.enabled = false;
        detalhesPedido.enabled = false;
    };
    
    this.cancelaEditaDadosPedido = function(args) {
        const activeWidget = templateManager.container.getActiveWidget();
        const itensPedidosWidget = templateManager.container.getWidget("itensPedidosWidget");
        const detalhesPedido = templateManager.container.getWidget("detalhesPedido");
        
        activeWidget.template = "widget/form-view.html";
        activeWidget.reload();
        
        General.backOrCancel(args);
        
        activeWidget.list();
        activeWidget.reload();
        
        activeWidget.currentRow = activeWidget.oldRow;
        
        itensPedidosWidget.enabled = true;
        detalhesPedido.enabled = true;
    };
    
    this.salvaDadosPedido = function(widget) {
        const row = angular.copy(widget.currentRow);
        const itensPedidosWidget = templateManager.container.getWidget("itensPedidosWidget");
        const detalhesPedido = templateManager.container.getWidget("detalhesPedido");
        
        delete row.__rightActions;
        delete row.__leftActions;
        
        row.__isNew = false;
        
        row.DTPEDEXOL = moment(row.DTPEDEXOL, "DD/MM/YYYY").format("DD/MM/YYYY");
        
        if(widget.isValid()) {
            General.callRestEngine("opl_solicitacao#/salvaDadosPedido", "Row", row).then(function(response) {
                widget.template = "widget/form-view.html";
                widget.list();
                widget.reload();
                
                itensPedidosWidget.enabled = true;
                detalhesPedido.enabled = true;
                
                MessageService.showMessageByCode("PEDIDO_EDIT_SUCCESS");
            }).catch(function(error) {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            });
        }
    };
    
    this.adicionaNovoPedido = function(widget) {
        const widgetAdicionaNovoPedido = templateManager.container.getWidget("adicionaNovoPedido");
        const widgetTabbedNovoPedido = templateManager.container.getWidget("tabbedNovoPedidoWidget");
        const prodsNovoPedidoWidget = templateManager.container.getWidget("prodsNovoPedidoWidget");
        const itensPedidosWidget = templateManager.container.getWidget("itensPedidosWidget");
        const detalhesPedidoWidget = templateManager.container.getWidget("detalhesPedido");
        
        widgetAdicionaNovoPedido.currentRow = angular.copy(widget.currentRow);
        
        prodsNovoPedidoWidget.enabled = false;
        
        delete widgetAdicionaNovoPedido.currentRow.NRPEDEXOL;
        
        widgetAdicionaNovoPedido.currentRow.DTPEDEXOL = moment().format("L");
        widgetAdicionaNovoPedido.currentRow.CDFILLANC = getLocalVar("CDFILIAL");
        widgetAdicionaNovoPedido.currentRow.NMFILLANC = getLocalVar("NMFILIAL");
        
        itensPedidosWidget.enabled = false;
        
        detalhesPedidoWidget.enabled = false;
        
        self.destinatarioNF(widgetAdicionaNovoPedido);
        
        ScreenService.openSwipe(widgetTabbedNovoPedido);
    };
    
    this.baixaManualPedido = function(widget) {
        const itensPedidosWidget = templateManager.container.getWidget("itensPedidosWidget");
        
        widget.currentRow.NEW_IDBAIXEXOL = 3;
        widget.currentRow.NEW_DTBAIXTMPEOL = moment().format('L');
        
        MessageService.confirmMessageByCode("BAIXA_MANUAL_PEDIDO_ASK").then(function(confirmed) {
            General.callRestEngine("opl_solicitacao#/baixaManualPedido", "Row", widget.currentRow).then(function(response) {
                delete widget.currentRow.NEW_IDBAIXEXOL;
                widget.currentRow.IDBAIXEXOL = 3;
                
                itensPedidosWidget.reload();
                
                widget.getAction("editaDadosPedido").isVisible = false;
                widget.getAction("baixaManualPedido").isVisible = false;
                widget.getAction("cancelarPedido").isVisible = false;
                widget.getAction("encerrarPedido").isVisible = false;
                widget.getAction("exportarPedido").isVisible = false;
                widget.getAction("excluiPedido").isVisible = false;
                widget.getAction("emAbertoPedido").isVisible = true;
                
                ScreenService.closePopup();
                
                MessageService.showMessageByCode("BAIXA_MANUAL_SUCCESS");
            }).catch(function(error) {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            });
        });
    };
    
    this.cancelarEncerrarPedido = function(widget, op) {
        const itensPedidosWidget = templateManager.container.getWidget("itensPedidosWidget");
        var message1, message2;
        
        widget.currentRow.NEW_IDBAIXEXOL = op;
        
        if(op == 5) {
            message1 = "CANCELA_PEDIDO_ASK";
            message2 = "CANCELA_PEDIDO_SUCCESS";
        } else {
            message1 = "ENCERRA_PEDIDO_ASK";
            message2 = "ENCERRA_PEDIDO_SUCCESS";
        }
        
        MessageService.confirmMessageByCode(message1).then(function(confirmed) {
            General.callRestEngine("opl_solicitacao#/cancelaEncerraPedido", "Row", widget.currentRow).then(function(response) {
                delete widget.currentRow.NEW_IDBAIXEXOL;
                widget.currentRow.IDBAIXEXOL = op;
                
                itensPedidosWidget.reload();
                
                widget.getAction("editaDadosPedido").isVisible = false;
                widget.getAction("baixaManualPedido").isVisible = false;
                widget.getAction("cancelarPedido").isVisible = false;
                widget.getAction("encerrarPedido").isVisible = false;
                widget.getAction("exportarPedido").isVisible = false;
                widget.getAction("excluiPedido").isVisible = false;
                widget.getAction("emAbertoPedido").isVisible = true;
                
                ScreenService.closePopup();
                
                MessageService.showMessageByCode(message2);
            }).catch(function(error) {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            });
        });
    };
    
    this.emAbertoPedido = function(widget) {
        const itensPedidosWidget = templateManager.container.getWidget("itensPedidosWidget");
        
        widget.currentRow.NEW_IDBAIXEXOL = 0;
        
        MessageService.confirmMessageByCode("EMABERTO_PEDIDO_ASK").then(function(confirmed) {
            General.callRestEngine("opl_solicitacao#/emAbertoPedido", "Row", widget.currentRow).then(function(response) {
                delete widget.currentRow.NEW_IDBAIXEXOL;
                widget.currentRow.IDBAIXEXOL = null;
                
                itensPedidosWidget.reload();
                
                widget.getAction("editaDadosPedido").isVisible = true;
                widget.getAction("baixaManualPedido").isVisible = true;
                widget.getAction("cancelarPedido").isVisible = true;
                widget.getAction("encerrarPedido").isVisible = true;
                widget.getAction("excluiPedido").isVisible = true;
                widget.getAction("emAbertoPedido").isVisible = false;
                
                if(parametrosParaSupri && parametrosParaSupri.IDENVIOITMPEDOL == 'S') {
                    widget.getAction("exportarPedido").isVisible = true;
                } else {
                    widget.getAction("exportarPedido").isVisible = false;
                }
                
                ScreenService.closePopup();
                
                MessageService.showMessageByCode("EMABERTO_SUCCESS");
            }).catch(function(error) {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            });
        });
    };
    
    this.excluiPedido = function(widget) {
        const itensPedidosWidget = templateManager.container.getWidget("itensPedidosWidget");
        const stripeWidget = templateManager.container.getWidget("stripeWidget");
        const detalhesPedidoWidget = templateManager.container.getWidget("detalhesPedido");
        
        MessageService.confirmMessageByCode("EXCLUIR_PEDIDO_ASK").then(function(confirmed) {
            General.callRestEngine("opl_solicitacao#/exclusaoPedido", "Row", widget.currentRow).then(function(response) {
                widget.currentRow = {};
                widget.enabled = false;
                
                itensPedidosWidget.currentRow = {};
                itensPedidosWidget.activate();
                itensPedidosWidget.reload();
                
                stripeWidget.currentRow = {};
                
                detalhesPedidoWidget.enabled = false;
                
                MessageService.showMessageByCode("EXCLUSAO_REALIZADA");
            }).catch(function(error) {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            });
        });
    };
    
    this.cancelarNovoPedido = function(widget) {
        const widgetDadosPedido = templateManager.container.getWidget("dadosPedido");
        const itensPedidosWidget = templateManager.container.getWidget("itensPedidosWidget");
        const detalhesPedidoWidget = templateManager.container.getWidget("detalhesPedido");
        
        MessageService.confirmMessageByCode("CANCEL_NOVO_PEDIDO").then(function(confirmed) {
            itensPedidosWidget.enabled = true;
        
            detalhesPedidoWidget.enabled = true;
            
            ScreenService.closeSwipe();
            ScreenService.closeSwipe();
            
            widgetDadosPedido.activate();
        });
    };
    
    this.abrirAbaProdutos = function(widget) {
        const prodsNovoPedidoWidget = templateManager.container.getWidget("prodsNovoPedidoWidget");
        
        prodsNovoPedidoWidget.enabled = true;
        
        prodsNovoPedidoWidget.activate();
    };
    
    this.adicionaNovoProdutoPedido = function(widget) {
        const inclusaoProdutoNovoPedidoWidget = templateManager.container.getWidget("inclusaoProdutoNovoPedidoWidget");
        
        var mascaraProduto = getLocalVar('CDPICTPROD');
        var fieldProduto = inclusaoProdutoNovoPedidoWidget.getField('NMPRODUTO');
        
        mascaraProduto = mascaraProduto.split('.');
        
        var nivelProduto = mascaraProduto.length;
        
        fieldProduto.dataSourceFilter.forEach(function(filtro) {
            if(filtro.name == 'CDNVPRODUTO')
                filtro.value = nivelProduto;
        });
        
        inclusaoProdutoNovoPedidoWidget.currentRow.DTPROGENPEOL = moment().format('L');
        
        ScreenService.openPopup(inclusaoProdutoNovoPedidoWidget);
    };
    
    this.salvaInclusaoProdutoNvoPedido = function(widget) {
        const dataProc = moment(getLocalVar("DTPROCESSA"), "DD/MM/YYYY").format("MM-DD-YYYY");
        const dataEscd = moment(widget.currentRow.DTPROGENPEOL, "DD/MM/YYYY").format("MM-DD-YYYY");
        const prodsNovoPedidoWidget = widget.getParent();
        
        if(widget.isValid()) {
            if(moment(dataEscd).isSameOrAfter(dataProc)) {
                if(prodsNovoPedidoWidget.dataSource.data.length == 0) {
                    prodsNovoPedidoWidget.dataSource.data.push(angular.copy(widget.currentRow));
                    
                    widget.currentRow = {};
                    
                    ScreenService.closePopup();
                    
                    MessageService.showMessageByCode("PRODUCT_INSERT_LIST_SUCCESS");
                } else {
                    var podeInserir = true;
                    
                    prodsNovoPedidoWidget.dataSource.data.forEach(row => {
                        if(row.DTPROGENPEOL == widget.currentRow.DTPROGENPEOL && row.CDMARCA == widget.currentRow.CDMARCA && row.CDPRODESTO == widget.currentRow.CDPRODESTO) {
                            podeInserir = false;
                        }
                    });
                    
                    if(podeInserir) {
                        prodsNovoPedidoWidget.dataSource.data.push(angular.copy(widget.currentRow));
                        
                        widget.currentRow = {};
                    
                        ScreenService.closePopup();
                        
                        MessageService.showMessageByCode("PRODUCT_INSERT_LIST_SUCCESS");
                    } else {
                        MessageService.showMessageByCode("ITEM_ALREADY_EXISTS_PEDIDO");
                    }
                }
            } else {
                MessageService.showMessageByCode("DATA_MAIOR_IGUAL_PROCESSAMENTO");
            }
        }
    };
    
    this.excluiNovoProdutoPedido = function(widget) {
        const checkedRows = widget.getCheckedRows();
        const allRows = widget.dataSource.data;
        const returnRows = allRows.filter(function(rowA) {
            return !checkedRows.find(function(rowB) {
                return rowA.DTPROGENPEOL == rowB.DTPROGENPEOL && rowA.CDMARCA == rowB.CDMARCA && rowA.CDPRODESTO == rowB.CDPRODESTO;
            });
        });
        
        MessageService.confirmMessageByCode("CONFIRM_PRODUCT_DELETE_LIST").then(function(confirmed) {
            widget.dataSource.data = returnRows;
        });
    };
    
    this.finalizaNovoPedido = function(widget) {
        const adicionaNovoPedidoWidget = templateManager.container.getWidget("adicionaNovoPedido");
        const widgetDadosPedido = templateManager.container.getWidget("dadosPedido");
        const itensPedidosWidget = templateManager.container.getWidget("itensPedidosWidget");
        const widgetStripe = templateManager.container.getWidget("stripeWidget");
        const widgetDetalhesPedido = templateManager.container.getWidget("detalhesPedido");
        
        const rowFinal = {
            "DADOS": angular.copy(adicionaNovoPedidoWidget.currentRow),
            "PRODUTOS": angular.copy(widget.dataSource.data)
        };
        
        if(widget.dataSource.data.length > 0) {
            if(adicionaNovoPedidoWidget.isValid()) {
                MessageService.confirmMessageByCode("CONFIRMA_NOVO_PEDIDO").then(function(confirmed) {
                    General.callRestEngine("opl_solicitacao#/inclusaoPedido", "Row", rowFinal).then(function(response) {
                        widgetDadosPedido.currentRow = adicionaNovoPedidoWidget.currentRow;
                        widgetDadosPedido.getAction("editaDadosPedido").isVisible = true;
                        widgetDadosPedido.getAction("baixaManualPedido").isVisible = true;
                        widgetDadosPedido.getAction("cancelarPedido").isVisible = true;
                        widgetDadosPedido.getAction("encerrarPedido").isVisible = true;
                        widgetDadosPedido.getAction("excluiPedido").isVisible = true;
                        widgetDadosPedido.getAction("emAbertoPedido").isVisible = false;
                        
                        if(parametrosParaSupri && parametrosParaSupri.IDENVIOITMPEDOL == 'S') {
                            widgetDadosPedido.getAction("exportarPedido").isVisible = true;
                        } else {
                            widgetDadosPedido.getAction("exportarPedido").isVisible = false;
                        }
                        
                        adicionaNovoPedidoWidget.currentRow = {};
                        
                        itensPedidosWidget.currentRow = {};
                        itensPedidosWidget.reload();
                        itensPedidosWidget.enabled = true;
                        
                        widgetStripe.currentRow = {};
                        
                        widget.dataSource.data = [];
                        
                        widgetDetalhesPedido.enabled = true;
                        
                        ScreenService.closeSwipe();
                        ScreenService.closeSwipe();
                        
                        MessageService.showMessageByCode("NEW_PEDIDO_SUCCESS");
                    }).catch(function(error) {
                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                    });
                }).catch(function(declined) {
                    adicionaNovoPedidoWidget.activate();
                });
            } else {
                adicionaNovoPedidoWidget.activate();
                
                MessageService.showMessageByCode("OBRIGATORY_FIELDS");
            }
        } else {
            MessageService.showMessageByCode("ONE_PRODUCT_NEC_INSERT");
        }
    };
    
    this.exportarPedido = function(widget) {
        MessageService.confirmMessageByCode("CONFIRM_EXPORT_PEDIDO").then(function(confirmed) {
            General.callRestEngine("opl_solicitacao#/exportarPedidoOL", "Row", widget.currentRow).then(function(response) {
                ScreenService.closePopup();
                
                MessageService.showMessageByCode("PEDIDO_EXPORTADO_SUCESSO");
            }).catch(function(error) {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            });
        });
    };
    
    this.importacaoSolicitacaoOL = function(widget) {
        const importacaoSolicitacaoComprasOLWidget = templateManager.container.getWidget("importacaoSolicitacaoComprasOLWidget");
        
        importacaoSolicitacaoComprasOLWidget.currentRow = {};
        
        ScreenService.openPopup(importacaoSolicitacaoComprasOLWidget);
    };
    
    this.readOnlyImportSolFields = function(widget) {
        const fieldNaoConsid = widget.getField("NCONSIDERASUBGRUPO");
        const fieldSubgrupo = widget.getField("CDSUBGRPROD");
        const fieldProdIni = widget.getField("NMPRODINI");
        const fieldProdFin = widget.getField("NMPRODFIN");
        
        fieldNaoConsid.readOnly = widget.currentRow.TODOSPRODUTOS == 'S' ? true : false;
        
        fieldSubgrupo.readOnly = widget.currentRow.TODOSPRODUTOS == 'S' ? true : widget.currentRow.NCONSIDERASUBGRUPO == 'S' ? true : false;
        
        fieldProdIni.readOnly = widget.currentRow.TODOSPRODUTOS == 'S' ? true : false;
        
        fieldProdFin.readOnly = widget.currentRow.TODOSPRODUTOS == 'S' ? true : false;
        
        if(widget.currentRow.TODOSPRODUTOS == 'S') {
            widget.currentRow.CDSUBGRPROD = null;
            widget.currentRow.NCONSIDERASUBGRUPO = 'S';
            widget.currentRow.NMPRODINI = null;
            widget.currentRow.CDPRODINI = null;
            widget.currentRow.NMPRODFIN = null;
            widget.currentRow.CDPRODFIN = null;
            
            delete fieldProdIni.validations;
            delete fieldProdFin.validations;
        } else {
            fieldProdIni.validations = {
                "required": true
            };
            fieldProdFin.validations = {
                "required": true
            };
        }
        
        widget.activate();
    };
    
    this.confirmaImportSolOL = function(widget) {
        const itensPedidosWidget = templateManager.container.getWidget("itensPedidosWidget");
        const widgetDetalhesPedido = templateManager.container.getWidget("detalhesPedido");
        
        widget.currentRow.CDFILLANC = getLocalVar("CDFILIAL");
        widget.currentRow.CDPRODINI = widget.currentRow.CDPRODINI ? widget.currentRow.CDPRODINI : null;
        widget.currentRow.CDPRODFIN = widget.currentRow.CDPRODFIN ? (widget.currentRow.CDPRODFIN + "ZZZZZZZZZZZZZZZZZZZZ").substr(0, 20) : null;
        widget.currentRow.CDREGIAOBKP = (!widget.currentRow.CDREGIAO || widget.currentRow.CDREGIAO.length == 0) ? null : '_' + widget.currentRow.CDREGIAO.join('_') + '_';
        widget.currentRow.CDSUBGRPRODBKP = (!widget.currentRow.CDSUBGRPROD || widget.currentRow.CDSUBGRPROD.length == 0) ? null : '_' + widget.currentRow.CDSUBGRPROD.join('_') + '_';
        widget.currentRow.CDGRUPPRODBKP = (!widget.currentRow.CDGRUPPROD || widget.currentRow.CDGRUPPROD.length == 0) ? null : widget.currentRow.CDGRUPPROD[0];
        widget.currentRow.CDGRUPFILIBKP = (!widget.currentRow.CDGRUPFILI || widget.currentRow.CDGRUPFILI.length == 0) ? null : '_' + widget.currentRow.CDGRUPFILI.join('_') + '_';
        
        if(widget.isValid()) {
            MessageService.confirmMessageByCode("CONFIRM_IMPORT_SOL_OL").then(function(confirmed) {
                General.callRestEngine("opl_solicitacao#/importacaoSolicitacaoOL", "Row", widget.currentRow).then(function(response) {
                    ScreenService.closePopup();
                    
                    itensPedidosWidget.reload();
                    
                    widgetDetalhesPedido.reload();
                    
                    MessageService.showMessageByCode("IMPORT_SUCCESS");
                }).catch(function(error) {
                    if(error.data.error == "ERROR_APUR" || error.data.error == "APUR_NOT_RESULTS") {
                        MessageService.showMessageByCode(error.data.error);
                    } else {
                        MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                    }
                });
            });
        } else {
            MessageService.showMessageByCode("OBRIGATORY_FIELDS");
        }
    };
    
    this.emissaoPedidosOL = function(widget) {
        const emissaoPedidosOLWidget = templateManager.container.getWidget("emissaoPedidosOLWidget");
        
        emissaoPedidosOLWidget.currentRow = {};
        emissaoPedidosOLWidget.currentRow.TCDLOTENVITOL = 'N';
        emissaoPedidosOLWidget.currentRow.IDBAIXAAFSAI = [ '0', '1', '2', '3' ];
        emissaoPedidosOLWidget.currentRow.IDBAIXAAFENT = [ '0', '1', '2', '3', '4', '5' ];
        emissaoPedidosOLWidget.currentRow.PEDOLEXTR = [ 'S', 'N' ];
        
        ScreenService.openPopup(emissaoPedidosOLWidget);
    };
    
    this.changeFieldRota = function(widget) {
        const fieldRota = widget.getField("CDROTATRANS");
        
        if(widget.currentRow.NCONSIDERAROTA === 'N') {
            fieldRota.readOnly = false;
            fieldRota.reload();
            fieldRota.setValue(null);
        } else {
            fieldRota.readOnly = true;
            fieldRota.reload();
            fieldRota.setValue(null);
        }
        
        widget.activate();
    };
    
    this.confirmaEmissaoPedidosOL = function(widget) {
        const row = angular.copy(widget.currentRow);
        var reportRow = {};
        
        reportRow.P_CDCLIENTE = '';
        reportRow.P_TCDCLIENTE = 'T';
        reportRow.P_CDFILIOL = Util.isEmptyOrBlank(row.CDFILIOPELOG) ? '' : '_' + row.CDFILIOPELOG.join('_') + '_';
        reportRow.P_TCDFILIOL = Util.isEmptyOrBlank(row.CDFILIOPELOG) ? 'T' : '';
        reportRow.L_ROTA = row.NCONSIDERAROTA === 'S' ? 'T' : Util.isEmptyOrBlank(row.CDROTATRANS) ? 'T' : '_' + row.CDROTATRANS.join('_') + '_';
        reportRow.L_ROTA1 = row.NCONSIDERAROTA === 'S' ? 'T' : Util.isEmptyOrBlank(row.CDROTATRANS) ? 'T' : '_' + row.CDROTATRANS.join('_') + '_';
        reportRow.P_ROTA = row.NCONSIDERAROTA === 'S' ? 'T' : Util.isEmptyOrBlank(row.CDROTATRANS) ? 'T' : '_' + row.CDROTATRANS.join('_') + '_';
        reportRow.P_CDFILIAL = Util.isEmptyOrBlank(row.CDFILDEST) ? '' : '_' + row.CDFILDEST.join('_') + '_';
        reportRow.P_TCDFILIAL = Util.isEmptyOrBlank(row.CDFILDEST) ? 'T' : '';
        reportRow.P_DTENTRINI = (Util.isEmptyOrBlank(row.DTPROGENPEOL.start) && Util.isEmptyOrBlank(row.DTPROGENPEOL.end)) ? '' : moment(row.DTPROGENPEOL.start, "DD/MM/YYYY").format('L');
        reportRow.P_DTENTRFIN = (Util.isEmptyOrBlank(row.DTPROGENPEOL.start) && Util.isEmptyOrBlank(row.DTPROGENPEOL.end)) ? '' : moment(row.DTPROGENPEOL.end, "DD/MM/YYYY").format('L');
        reportRow.P_TDTENTR = (Util.isEmptyOrBlank(row.DTPROGENPEOL.start) && Util.isEmptyOrBlank(row.DTPROGENPEOL.end)) ? 'T' : '';
        reportRow.P_DTEMBINI = (Util.isEmptyOrBlank(row.DTPROGEMBARQ.start) && Util.isEmptyOrBlank(row.DTPROGEMBARQ.end)) ? '' : moment(row.DTPROGEMBARQ.start, "DD/MM/YYYY").format('L');
        reportRow.P_DTEMBFIN = (Util.isEmptyOrBlank(row.DTPROGEMBARQ.start) && Util.isEmptyOrBlank(row.DTPROGEMBARQ.end)) ? '' : moment(row.DTPROGEMBARQ.end, "DD/MM/YYYY").format('L');
        reportRow.P_TDTEMB = (Util.isEmptyOrBlank(row.DTPROGEMBARQ.start) && Util.isEmptyOrBlank(row.DTPROGEMBARQ.end)) ? 'T' : '';
        reportRow.P_SUBGRUPO = row.NCONSIDERASUBGRUPO === 'S' ? 'N' : Util.isEmptyOrBlank(row.CDSUBGRPROD) ? 'T' : '_' + row.CDSUBGRPROD.join('_') + '_';
        reportRow.P_CDGRUPPROD = row.NCONSIDERASUBGRUPO === 'S' ? '' : parametrosParaSupri.CDGRUPPROD;
        reportRow.P_CDPRODINI = (Util.isEmptyOrBlank(row.CDPRODINI) && Util.isEmptyOrBlank(row.CDPRODFIN)) ? '' : row.CDPRODINI;
        reportRow.P_CDPRODFIN = (Util.isEmptyOrBlank(row.CDPRODINI) && Util.isEmptyOrBlank(row.CDPRODFIN)) ? '' : (row.CDPRODFIN + "ZZZZZZZZZZZZZZZZZZZZ").substr(0, 20);
        reportRow.P_CDPRODFINTEXT = (Util.isEmptyOrBlank(row.CDPRODINI) && Util.isEmptyOrBlank(row.CDPRODFIN)) ? '' : row.CDPRODFIN;
        reportRow.L_PRODUTO = (Util.isEmptyOrBlank(row.CDPRODINI) && Util.isEmptyOrBlank(row.CDPRODFIN)) ? 'T' : 'X';
        reportRow.P_PRODUTO = (Util.isEmptyOrBlank(row.CDPRODINI) && Util.isEmptyOrBlank(row.CDPRODFIN)) ? 'T' : 'X';
        reportRow.L_OPERADOR = parametrosGerais.IDRESTRFILIOPER === 'S' ? getLocalVar("CDOPERADOR") : 'T';
        reportRow.L_OPERADOR1 = parametrosGerais.IDRESTRFILIOPER === 'S' ? getLocalVar("CDOPERADOR") : 'T';
        reportRow.P_OPERADOR = parametrosGerais.IDRESTRFILIOPER === 'S' ? getLocalVar("CDOPERADOR") : 'T';
        reportRow.P_NMPRODINI = Util.isEmptyOrBlank(row.NMPRODINI) ? '' : row.NMPRODINI;
        reportRow.P_NMPRODFIN = Util.isEmptyOrBlank(row.NMPRODFIN) ? '' : row.NMPRODFIN;
        reportRow.P_IDSITUACAO = 'P';
        reportRow.P_IDBAIXEXOL = '_' + row.IDBAIXAAFENT.join('_') + '_';
        reportRow.P_IDBAIXEXSAI = '_' + row.IDBAIXAAFSAI.join('_') + '_';
        reportRow.P_PEDEXOLEXTR = row.PEDOLEXTR.length == 2 ? 'T' : row.PEDOLEXTR[0] === 'S' ? 'S' : 'N';
        reportRow.P_CDLOTENVITOL = row.TCDLOTENVITOL === 'S' ? 'S' : row.TCDLOTENVITOL === 'N' ? 'N' : row.TCDLOTENVITOL === 'L' ? Util.isEmptyOrBlank(row.CDLOTENVITOL) ? 'T' : '_' + row.CDLOTENVITOL.join('_') + '_' : 'T';
        reportRow.P_NRSEQRUPTURAOL = '';
        reportRow.P_TNRSEQRUPTURAOL = 'T';
        reportRow.STRATEGY = widget.currentRow.RELATORIO.split('.')[1];
        
        if(widget.isValid() && reportRow.STRATEGY) {
            General.openReportPopup(widget, this.openReport, [widget, reportRow, widget.currentRow.RELATORIO.split('.')[0]]);
        }
    };
    
    this.openReport = function(widget, row, reportName) {
        row.QR2TYPE = widget.currentRow.QR2TYPE;
        row.STRATEGY = widget.currentRow.RELATORIO.split('.')[1];
        
        General.openReport("opl_solicitacao#/sup07200_relatorio", reportName, row).then(success => {
            console.log(success);
        }).catch(error => {
            MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
        });
    };
    
    this.prodQtdeInlineChange = function(widget) {
        const adicionaNovoPedidoWidget = templateManager.container.getWidget("adicionaNovoPedido");
        
        adicionaNovoPedidoWidget.enabled = false;
    };
    
    this.prodQtdeInlineCancel = function(widget) {
        const adicionaNovoPedidoWidget = templateManager.container.getWidget("adicionaNovoPedido");
        
        adicionaNovoPedidoWidget.enabled = true;
        
        widget.rollbackInlineEdit();
        widget.list();
    };
    
    this.prodQtdeInlineSave  = function(widget) {
        const adicionaNovoPedidoWidget = templateManager.container.getWidget("adicionaNovoPedido");
        
        adicionaNovoPedidoWidget.enabled = true;
        
        widget.commitInlineEdit();
        widget.list();
    };
    
    this.onChangeQtdeInline = function(widget) {
        const widgetDetalhesPedido = templateManager.container.getWidget("detalhesPedido");
        const widgetDadosPedido = templateManager.container.getWidget("dadosPedido");
        
        widgetDadosPedido.setEnabled(false);
        widgetDetalhesPedido.setEnabled(false);
        widget.showCheckbox = false;
    };
    
    this.onCancelInlineEdit = function(widget) {
        const widgetDetalhesPedido = templateManager.container.getWidget("detalhesPedido");
        const widgetDadosPedido = templateManager.container.getWidget("dadosPedido");
        
        if(widget.currentRow.NRPEDEXOL) {
            widgetDadosPedido.enabled = true;
            widgetDetalhesPedido.enabled = true;
        }
        
        widget.showCheckbox = true;
        widget.rollbackInlineEdit();
        widget.list();
    };
    
    this.onSaveInlineEdit = function(widget) {
        const widgetDetalhesPedido = templateManager.container.getWidget("detalhesPedido");
        const widgetDadosPedido = templateManager.container.getWidget("dadosPedido");
        const changedRows = widget.dataSource.data.filter(row => {
            return (row.changed === true);
        });
        const rowsLiberadas = widget.dataSource.data.filter(row => {
            return (row.changed === true && (row.IDBAIXEXOL == null || row.IDBAIXEXOL == 0 || row.IDBAIXEXOL == 1) && (row.IDBAIXENPEOL == null || row.IDBAIXENPEOL == 0 || row.IDBAIXENPEOL == 1));
        });
        
        if(rowsLiberadas.length == changedRows.length) {
            MessageService.confirmMessageByCode("QTPROGENPEOL_DELETE_ZERO").then(function(confirmed) {
                rowsLiberadas.forEach(row => {
                   row.NEW_QTPROGENPEOL = row.QTPROGENPEOL_inline;
                   row.OLD_QTPROGENPEOL = row.changed_QTPROGENPEOL;
                   row.DTPROGENPEOL = moment(row.DTPROGENPEOL, "DD/MM/YYYY").format("DD/MM/YYYY");
                });
                
                General.callRestEngine("opl_solicitacao#/alteraQuantidadeItemPedidoOLInline", "Row", rowsLiberadas).then(function(response) {
                    if(widget.currentRow.NRPEDEXOL) {
                        widgetDadosPedido.enabled = true;
                        widgetDetalhesPedido.enabled = true;
                    }
                    
                    widget.showCheckbox = true;
                    widget.commitInlineEdit();
                    widget.list();
                    widget.reload();
                    widget.activate();
                    
                    MessageService.showMessageByCode("QTPROGENPEOL_EDIT_SUCCESS");
                }).catch(function(error) {
                    if(widget.currentRow.NRPEDEXOL) {
                        widgetDadosPedido.enabled = true;
                        widgetDetalhesPedido.enabled = true;
                    }
                    
                    widget.showCheckbox = true;
                    widget.rollbackInlineEdit();
                    widget.list();
                    
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                });
            });
        } else {
            MessageService.showMessageByCode("ONLY_EMABERTO_PARCIAL_ITENS_PEDIDO_EDIT");
            
            if(widget.currentRow.NRPEDEXOL) {
                widgetDadosPedido.enabled = true;
                widgetDetalhesPedido.enabled = true;
            }
            
            widget.showCheckbox = true;
            widget.rollbackInlineEdit();
            widget.list();
        }
    };
    
    this.cancelaNovoItemPedido = function(widget) {
        MessageService.confirmMessageByCode("CANCEL_NOVO_ITEM_PEDIDO").then(function(confirmed) {
            ScreenService.closeSwipe();
            widget.getParent().activate();
            widget.getParent().list();
        });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register("Sup07200_lancamento_de_pedidos_Controller", Sup07200_lancamento_de_pedidos_Controller);
});